import _createClass from "@babel/runtime/helpers/createClass";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import cx from 'classnames';
import SUILoader from './SUILoader';
var TYPES = {
  FULL: 'full',
  SECTION: 'section'
};
var DELAY = 500; // ms

var BASE_CLASS = 'sui-AtomSpinner';

var AtomSpinner =
/*#__PURE__*/
function (_Component) {
  _inheritsLoose(AtomSpinner, _Component);

  function AtomSpinner() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.state = {
      delayed: _this.props.delayed
    };
    return _this;
  }

  var _proto = AtomSpinner.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    if (!this.state.delayed) {
      this._addParentClass();

      return;
    }

    this.timer = setTimeout(function () {
      _this2.setState({
        delayed: false
      }, _this2._addParentClass);
    }, DELAY);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    clearTimeout(this.timer);

    this._removeParentClass();
  };

  _proto._removeParentClass = function _removeParentClass() {
    this._parentNodeClassList.remove(this._parentClassName);
  };

  _proto._addParentClass = function _addParentClass() {
    this._parentNodeClassList.add(this._parentClassName);
  };

  _proto.render = function render() {
    var loader = this.props.loader;
    var delayed = this.state.delayed;
    return !delayed ? loader : React.createElement("noscript", null);
  };

  _createClass(AtomSpinner, [{
    key: "_parentNodeClassList",
    get: function get() {
      if (this._parentNodeClassListCache) return this._parentNodeClassListCache;
      this._parentNodeClassListCache = ReactDOM.findDOMNode(this).parentNode.classList;
      return this._parentNodeClassListCache;
    }
  }, {
    key: "_parentClassName",
    get: function get() {
      var type = this.props.type;
      return cx(type === TYPES.SECTION ? BASE_CLASS : BASE_CLASS + "--fullPage");
    }
  }]);

  return AtomSpinner;
}(Component);

AtomSpinner.displayName = 'AtomSpinner';
AtomSpinner.defaultProps = {
  delayed: false,
  type: TYPES.SECTION,
  loader: React.createElement(SUILoader, null)
};
export default AtomSpinner;
export { TYPES as AtomSpinnerTypes };